#ifndef _PIXCS_HXX
#define _PIXCS_HXX 1 

#ifndef _LIMITS_H
#include <limits.h>
#endif

/*
 *	device coordinate system, based on PIXELS
 *	Rectangles are given be the array RECT. It holds the
 *	coordinates of the points associated with the MINM and
 *	MAXM values, thus [MINM] >= [MAXM] is legal.  
 *
 *	ATTENTION: This notation is different to the X Rectangles,
 *	(x,y,w,h) where width or height may be zero. 
 *	!A RECT is always regular, you cannot express the empty set!
 *	[MINM][X]=leftmost X 
 *	[MAXM][X]=rightmost X 
 *	[MINM][Y]=bottommost Y 	ATTENTION - RECT THIS IS NOT X11 !!!
 *	[MAXM][X]=topmost Y 
 */
typedef int RECT[2][2];

/* the LAW */
#ifndef MINM
#define MINM 0
#define MAXM 1
#endif
#ifndef X
#define X 0
#define Y 1
#endif

/*
 *	Complementary dimension macro
 */
#define PCS_COMPL_DIM(i) (~(i) & 1)
#define PCS_IS_DIM(i) ((i)==X || (i) == Y)
#define PCS_DIM 2 

#define PCS_MASK_X 1
#define PCS_MASK_Y 2

#define PCS_IN_MASK(iDim, fMask) ((fMask) & ( 1<<(iDim)))

/*
 *	underflow, overflow exception
 *	pixels
 */
#define PCS_PIXUFL (-INT_MAX)
#define PCS_PIXOFL ( INT_MAX)
#define	PCS_ISXFLOW(x) ((x) == PCS_PIXUFL || (x) == PCS_PIXOFL)

#endif
