set -e

#
# assign variables
#
getarch() {
  ARCH=$(uname -i)
  case $ARCH in
    i386) ISA=x86$1; CCS=gcc3 ;;
    x86_64) ISA=a64; CCS=gcc4 ;;
  esac

  case $(gcc -v 2>&1) in
    *4.1.*) CCS=gcc4 ;;
  esac

  [ -z "$ISA" ] && { echo "unsupported architecture ($ARCH), please contact support@inesinc.com"; exit; }
  [ -n "$IDREP" ] && LIB_DIR=$IDREP/lkern_${ISA}_${CCS}/lib || LIB_DIR=$PWD/../arch/lkern_${ISA}_${CCS}/lib
}

[ -n "$IDSRC" ] && GPIB_INCLUDES="-I$IDSRC/gpib/_i_umi.120 -I$IDSRC/gpib/_i_umic.120 -I$IDSRC/gpib/_i_gpib.120 -I$IDSRC/gpib/_i_gpibc.120" || GPIB_INCLUDES="-I$PWD/../include"
GPIB_LIBS="-lgpibc_120 -lcplRaw_100 -lumic_120"


#
# first pass
#
getarch 
echo $LIB_DIR
make  -C /lib/modules/$(uname -r)/build SUBDIRS=$PWD GPIB_INCLUDES="$GPIB_INCLUDES" GPIB_LIB_DIR=$LIB_DIR GPIB_LIBS="$GPIB_LIBS" modules 

#
# optional second pass
# for kernels compile with -mregparm=[123]
#
fgrep -q "regparm=3" .user.o.cmd && {
  rm -f *.o *.ko igpib.mod.c
  getarch rp3
  echo $LIB_DIR
  make  -C /lib/modules/$(uname -r)/build SUBDIRS=$PWD GPIB_INCLUDES="$GPIB_INCLUDES" GPIB_LIB_DIR=$LIB_DIR GPIB_LIBS="$GPIB_LIBS"  modules 
  exit
}
grep -q -e "regparm=[12]" .user.o.cmd && { echo "Kernel not supported, contact support@inesinc.com"; exit; }

